/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

(function(window) {

function createCheckerOrt(x1, y1, x2, y2) {
    return function() {
        if (!this.pfeile.length)
            return 'Zeichne zuerst einen Pfeil ein, der vom Gegenstand zum virtuellen Bild zeigt…';
        const lastPfeil = this.pfeile[this.pfeile.length - 1];
//console.log({ x1: lastPfeil.x1, y1: lastPfeil.y1, x2: lastPfeil.x2, y2: lastPfeil.y2 });return true;
        return (lastPfeil.x1 == x1 && lastPfeil.y1 == y1 && lastPfeil.x2 == x2 && lastPfeil.y2 == y2);
    }
}

const LEVELS = [
    {
        "task": "<p>Du siehst einen Ausschnitt eines gespiegelten Lichtbündels. Ermittle den Ort des virtuellen Bildes und den des Gegenstandes. Zeichne zuletzt einen Pfeil vom Gegenstand zum virtuellen Bild.</p><p>Du kannst beliebig viele Pfeile als Hilfslinien einzeichnen, nur der letzte Pfeil muss der gesuchte Pfeil sein.</p>",
        "shadows": [
            { type: 'image', src: 'szenario1.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerOrt(35, 45, 55, 45)
    },
    {
        "task": "<p>Du siehst einen Ausschnitt eines gespiegelten Lichtbündels. Ermittle den Ort des virtuellen Bildes und den des Gegenstandes. Zeichne zuletzt einen Pfeil vom Gegenstand zum virtuellen Bild.</p><p>Du kannst beliebig viele Pfeile als Hilfslinien einzeichnen, nur der letzte Pfeil muss der gesuchte Pfeil sein.</p>",
        "shadows": [
            { type: 'image', src: 'szenario2.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerOrt(55, 30, 35, 30)
    },
    {
        "task": "<p>Du siehst einen Ausschnitt eines gespiegelten Lichtbündels. Ermittle den Ort des virtuellen Bildes und den des Gegenstandes. Zeichne zuletzt einen Pfeil vom Gegenstand zum virtuellen Bild.</p><p>Du kannst beliebig viele Pfeile als Hilfslinien einzeichnen, nur der letzte Pfeil muss der gesuchte Pfeil sein.</p>",
        "shadows": [
            { type: 'image', src: 'szenario3.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerOrt(55, 15, 65, 25)
    }
];

window.karokonstruktionTask = {
    levels: LEVELS
};
})(window);
